#! /bin/bash

THREADS=32
VERSION=3.3.10

if [ $# -lt 1 ]
then
    echo "USAGE: $0 <c_compiler=icx,gcc,etc> [THREADS=${THREADS}]";
    exit -1
fi
c_compiler=$1

if [ $# -gt 1 ]
then
    THREADS=$2
fi

echo "THREADS = ${THREADS}"

FFTW_DIR=./fftw
mkdir -p ${FFTW_DIR}
prefix=$(realpath ${FFTW_DIR})
cd ${prefix}

curl -O https://www.fftw.org/fftw-${VERSION}.tar.gz
tar -zxf fftw-${VERSION}.tar.gz
cd fftw-${VERSION}
CC=${c_compiler} ./configure --enable-openmp --disable-mpi --disable-fortran --prefix=${prefix} > ../config.log 2>&1
make -j ${THREADS} > ../make.log 2>&1
make install > ../install.log 2>&1
