#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <sycl/sycl.hpp>
#include <oneapi/mkl.hpp>

// #include <fftw3.h>

// // HACC
// #include "complex-type.h"

typedef oneapi::mkl::dft::descriptor<oneapi::mkl::dft::precision::DOUBLE,
				     oneapi::mkl::dft::domain::COMPLEX> descriptor_t;


// #define FFTW_ADDR(X) reinterpret_cast<fftw_complex*>(&(X)[0])

// double mygettimeofday() {
//   timeval tv;
//   gettimeofday(&tv, NULL);
//   return 1.0*tv.tv_sec + 1.0e-6 * tv.tv_usec;
// }

// class FFT1D {
// public:

//   FFT1D(int size, int howmany, unsigned flags) :
//     size(size),
//     howmany(howmany),
//     flags(flags)
//   {
//     n_elem = (size_t)size * (size_t)howmany;
//     ra = (complex_t *)fftw_malloc(n_elem*sizeof(complex_t));
//     ka = (complex_t *)fftw_malloc(n_elem*sizeof(complex_t));
//     double t0 = mygettimeofday();
//     makePlans();
//     double t1 = mygettimeofday();
//     t_plan = t1 - t0;
//   }

//   ~FFT1D() {
//     fftw_free(ra);
//     fftw_free(ka);
//     fftw_destroy_plan(plan_f);
//     fftw_destroy_plan(plan_b);
//   }
  
//   void makePlans() {
//     const int n[1] = {size};

//     // forward FFT from ra to ka
//     plan_f = fftw_plan_many_dft(1,             // int rank,
// 				n,             // const int *n,
// 				howmany,       // int howmany,
// 				FFTW_ADDR(ra), // fftw_complex *in,
// 				NULL,          // const int *inembed,
// 				1,             // int istride,
// 				size,          // int idist,
// 				FFTW_ADDR(ka), // fftw_complex *out,
// 				NULL,          // const int *onembed,
// 				1,             // int ostride,
// 				size,          // int odist,
// 				FFTW_FORWARD,  // int sign,
// 				flags);        // unsigned flags

//     // backward FFT from ka to ra
//     plan_b = fftw_plan_many_dft(1,             // int rank,
// 				&n[0],         // const int *n,
// 				howmany,       // int howmany,
// 				FFTW_ADDR(ka), // fftw_complex *in,
// 				NULL,          // const int *inembed,
// 				1,             // int istride,
// 				size,          // int idist,
// 				FFTW_ADDR(ra), // fftw_complex *out,
// 				NULL,          // const int *onembed,
// 				1,             // int ostride,
// 				size,          // int odist,
// 				FFTW_BACKWARD, // int sign,
// 				flags);        // unsigned flags
//   }

//   void setupDirac() {
//     complex_t zero(0.0, 0.0);
//     complex_t one(1.0, 0.0);
    
//     // fill r-space array with zeros
//     for(size_t i=0; i<n_elem; i++) {
//       ra[i] = zero;
//     }
    
//     // put one at beginning of each r-space sub-array
//     for(size_t j=0; j<howmany; j++) {
//       ra[j*size] = one;
//     }

//     // fill k space array with zeros
//     for(size_t i=0; i<n_elem; i++) {
//       ka[i] = zero;
//     }

    

    
//   }

//   size_t checkDiracR() {
//     complex_t zero(0.0, 0.0);
//     complex_t one(1.0, 0.0);

//     // pick up a factor of ng after forward/backward
//     one *= (1.0*size);
    
//     size_t nerrors=0;
//     for(size_t j=0; j<howmany; j++) {
//       size_t indx = j*size;
//       nerrors += (ra[indx] != one);
//       indx++;
//       for(size_t i=1; i<size; i++) {
// 	nerrors += (ra[indx] != zero);
// 	indx++;
//       }
//     }

//     return nerrors;
//   }

//   size_t checkDiracK() {
//     complex_t one(1.0, 0.0);

//     size_t nerrors=0;
//     for(size_t i=0; i<n_elem; i++)
//       nerrors += (ka[i] != one);

//     return nerrors;
//   }

//   size_t testDirac(int repetitions=1) {
//     for(size_t rep=0; rep<repetitions; rep++) {

//       printf("%zu\n",rep);

//       double t0, t1;
//       size_t nerrors;

//       // setup arrays for Dirac delta test
//       t0 = mygettimeofday();
//       setupDirac();
//       t1 = mygettimeofday();
//       printf("t_setup = %f seconds\n", t1-t0);

//       // forward FFT
//       t0 = mygettimeofday();
//       fftw_execute(plan_f);
//       t1 = mygettimeofday();
//       printf("t_fftf = %f seconds\n", t1-t0);

//       // check array in k-space
//       t0 = mygettimeofday();
//       nerrors = checkDiracK();
//       t1 = mygettimeofday();
//       printf("t_check = %f seconds\n", t1-t0);
//       printf("n_errors = %zu\n",nerrors);

//       // backward FFT
//       t0 = mygettimeofday();
//       fftw_execute(plan_b);
//       t1 = mygettimeofday();
//       printf("t_fftb = %f seconds\n", t1-t0);

//       // check array in r-space
//       t0 = mygettimeofday();
//       nerrors = checkDiracR();
//       t1 = mygettimeofday();
//       printf("t_check = %f seconds\n", t1-t0);
//       printf("n_errors = %zu\n",nerrors);

//       printf("\n");
//     }
  
// }
//   int size, howmany;
//   unsigned flags;
//   size_t n_elem;
//   complex_t *ra, *ka;
//   fftw_plan plan_f, plan_b;
//   double t_plan;


//   };


// using batch version of oneMKL FFT
void fft_c2c_batch_onemkl(int size, int howmany, int repetitions) {


    sycl::queue dev_que(sycl::gpu_selector_v,
			    sycl::property_list{sycl::property::queue::enable_profiling{},
				sycl::property::queue::in_order{}});

    size_t n_elem = size*howmany;
    // DPC++ version. factor of 2 for complex
    double *ra_dpcpp = (double *)malloc_shared(2*n_elem*sizeof(double), dev_que);
    double *ka_dpcpp = (double *)malloc_shared(2*n_elem*sizeof(double), dev_que);

    typedef oneapi::mkl::dft::descriptor<oneapi::mkl::dft::precision::DOUBLE,
					 oneapi::mkl::dft::domain::COMPLEX> descriptor_t;
    descriptor_t desc(size);
    desc.set_value(oneapi::mkl::dft::config_param::NUMBER_OF_TRANSFORMS, howmany);
    desc.set_value(oneapi::mkl::dft::config_param::FWD_DISTANCE, size);
    desc.set_value(oneapi::mkl::dft::config_param::BWD_DISTANCE, size);
    desc.set_value(oneapi::mkl::dft::config_param::PLACEMENT,
		   DFTI_NOT_INPLACE);

    desc.commit(dev_que);

    for(size_t rep=0; rep<repetitions; rep++) {
    
    printf("%zu\n",rep);
      
    
    // fill r-space array with zeros
    for(size_t i=0; i<2*n_elem; i++) {
      ra_dpcpp[i] = 0.0;
    }
    
    // put one at beginning of each r-space sub-array
    for(size_t j=0; j<howmany; j++) {
      ra_dpcpp[j*size*2] = 1.0;
    }

    // fill k space array with zeros
    for(size_t i=0; i<2*n_elem; i++) {
      ka_dpcpp[i] = 0.0;
    }


    auto fft = compute_forward(desc, ra_dpcpp, ka_dpcpp);
    fft.wait();
    auto submit_time = fft.get_profiling_info<sycl::info::event_profiling::command_submit>();
    auto start_time = fft.get_profiling_info<sycl::info::event_profiling::command_start>();
    auto end_time = fft.get_profiling_info<sycl::info::event_profiling::command_end>();
    auto submission_time = ((start_time - submit_time) / 1000000.0f);
    auto execution_time = ((end_time - start_time) / 1000000.0f);
    std::cout << "Batched API Forward (time in s) [kernel execution, submission] : " << execution_time << ", " << submission_time << std::endl;

    size_t nerrors = 0;
    for(size_t i=0; i<n_elem*2; i++)
      if( i % 2 ==0 ) {
	if( ka_dpcpp[i] != 1.0 ) {
	  nerrors += 1;
	  printf( "%zu: %lf\n", i, ka_dpcpp[i] );
	}
      }

    assert(nerrors == 0);

    
    fft = compute_backward(desc, ka_dpcpp, ra_dpcpp);
    fft.wait();
    submit_time = fft.get_profiling_info<sycl::info::event_profiling::command_submit>();
    start_time = fft.get_profiling_info<sycl::info::event_profiling::command_start>();
    end_time = fft.get_profiling_info<sycl::info::event_profiling::command_end>();
    submission_time = ((start_time - submit_time) / 1000000.0f);
    execution_time = ((end_time - start_time) / 1000000.0f);
    std::cout << "Batched API Backward (time in s) [kernel execution, submission] : " << execution_time << ", " << submission_time << std::endl;


    for(size_t j=0; j<howmany; j++) {
      size_t indx = j*size*2;
      if( ra_dpcpp[indx] != size ) {
	nerrors += 1;
	printf( "Non-zero %zu: %lf\n", indx, ra_dpcpp[indx] );
      }
      indx++;
      for(size_t i=1; i<size*2; i++) {
	if( (std::fabs(ra_dpcpp[indx]) - 0.0) > 0.0000001 ) {
	  nerrors += 1;
	  printf( "%zu: %9.8lf\n", indx, ra_dpcpp[indx] );
	}
	indx++;
      }
    }

    assert(nerrors == 0);
  }
    
  free(ra_dpcpp, dev_que);
  free(ka_dpcpp, dev_que);
    return;
}


int main(int argc, char *argv[]) {

  if(argc < 4) {
    printf("USAGE: %s <size> <howmany> <repetitions>\n", argv[0]);
    exit(-1);
  }
  int size = atoi(argv[1]);
  int howmany = atoi(argv[2]);
  int repetitions = atoi(argv[3]);


  fft_c2c_batch_onemkl(size, howmany,repetitions);

  
 
  
  return 0;
}
